"""In this script we create a random sequence rid of the 6pb enzyme restriction
sites listed in Biopython."""

from dnachisel import DnaOptimizationProblem, AvoidPattern, random_dna_sequence
from Bio.Restriction import AllEnzymes

# CREATE AN AvoidPattern CONSTRAINT FOR EACH ENZYME SITE OF LENGTH 6

constraints = [
    AvoidPattern("%s_site" % enzyme) for enzyme in AllEnzymes if enzyme.size == 6
]

# CREATE AN RESOLVE THE PROBLEM:

problem = DnaOptimizationProblem(
    sequence=random_dna_sequence(5000), constraints=constraints, logger=None
)
problem.resolve_constraints()

print("Final sequence:", problem.sequence)
